%     VIRTUAL LAMINATE - программа для получения эффективных свойств слоистых пластин
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Nodes = Find_Nodes(Nodes_Sorted, Ref_Node, Tolerance, Direction)

ind_1 = 1;
ind_2 = size(Nodes_Sorted,1);

while(1)
    
    i = floor((ind_1 + ind_2)/2);
    
    if (i == ind_2)
        Begin_Index = i;
        break;
    end
    
    if (i == ind_1)
        
        if (Nodes_Sorted(ind_1,Direction) > Ref_Node(1,Direction) - Tolerance)
            Begin_Index = ind_1;
        else
            Begin_Index = ind_2;
        end
        
        break;
    end
    
    if ((Nodes_Sorted(i,Direction) > Ref_Node(1,Direction) - Tolerance) && (Nodes_Sorted(i-1,Direction) <= Ref_Node(1,Direction) - Tolerance))
        Begin_Index = i;
        break;
    end
    
    if (Nodes_Sorted(i-1,Direction) > Ref_Node(1,Direction) - Tolerance)
        ind_2 = i-1;
    else
        ind_1 = i;
    end
    
end

ind_1 = 1;
ind_2 = size(Nodes_Sorted,1);

while(1)
    
    i = ceil((ind_1 + ind_2)/2);
    
    if (i == ind_1)
        End_Index = i;
        break;
    end
    
    if (i == ind_2)
        
        if (Nodes_Sorted(ind_2,Direction) < Ref_Node(1,Direction) + Tolerance)
            End_Index = ind_2;
        else
            End_Index = ind_1;
        end
        
        break;
    end
    
    if ((Nodes_Sorted(i,Direction) < Ref_Node(1,Direction) + Tolerance) && (Nodes_Sorted(i+1,Direction) >= Ref_Node(1,Direction) + Tolerance))
        End_Index = i;
        break;
    end
    
    if (Nodes_Sorted(i+1,Direction) < Ref_Node(1,Direction) + Tolerance)
        ind_1 = i+1;
    else
        ind_2 = i;
    end
    
end

Nodes = zeros(End_Index - Begin_Index + 1, 4);

for i=1:size(Nodes)
    
    Nodes(i,:) = Nodes_Sorted(Begin_Index - 1 + i,:);
    
end
